use strict;
use GD;

my $dx = 8;
my $line = GetLine();
$line =~ m/:(\d+),(\d+)/;
my ($nrows, $nperrow) = ($1, $2);
my $npixels = $nrows * $nperrow;
my $count = 0;
my $dim = $nperrow * $dx;
my $dy = $dim / $nrows;
my $img = GD::Image->new($dim, $dim);

print "$npixels pixels in $nrows rows x $nperrow per row.\n";

foreach (0 .. 255) {
	if ($_ < 85) {
		$img->colorAllocate($_ * 3, 0, 0)
	} elsif ($_ < 170) {
		$img->colorAllocate(255, ($_ - 85) * 3, 0)
	} else {
		$img->colorAllocate(255, 255, ($_ - 170) * 3)
	}
}

while (1) {
	my $ptemp = GetLine();
	if ($ptemp) {
		my @temps = ();
		push @temps, split(/,/, GetLine()) foreach (1 .. $nrows);
		my ($min, $max) = (sort {$a <=> $b} @temps)[0, -1];
		
		foreach my $i (0 .. @temps - 1) {
			my $x = $i % $nperrow;
			my $y = int($i / $nperrow);
			my $intens = int(($temps[$i] - $min) * 255 / ($max - $min));
			$img->filledRectangle($x * $dx, $y * $dy, ($x + 1) * $dx - 1, ($y + 1) * $dy - 1, $intens)
		}
		
		open IMG, ">/download/heatmap$count.png" or die;
		binmode IMG;
		print IMG $img->png;
		close IMG;
		$count++
	} else {
		last
	}
}


sub GetLine {
	$_ = <DATA>;
	chomp;
	return $_
}

__END__
:8,25
14910
0,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-3,-3,-2,0,-3,-2,-2,-2,-3,0,-2,0,-2,-2
1,0,0,1,1,0,0,0,1,0,0,1,0,0,0,1,0,1,3,3,0,1,-3,-2,1
0,0,0,0,0,0,0,-2,-2,1,1,1,1,0,0,1,0,0,0,1,3,-2,0,0,0
-2,0,-2,-3,-5,-5,-5,-5,-5,-3,-5,-5,-5,-3,-2,0,0,0,0,0,0,1,3,1,3
0,1,0,0,0,-2,0,0,-2,0,0,0,0,0,1,1,1,1,1,1,1,1,3,3,3
4,4,4,3,4,3,4,6,4,4,4,6,6,3,4,3,3,6,6,7,7,6,9,7,9
7,10,7,6,9,7,7,7,6,6,7,7,7,6,9,7,10,10,7,10,10,9,7,10,9
7,6,9,9,10,9,7,7,9,9,7,6,6,7,7,7,9,7,10,9,7,7,9,9,9
0